scala.collection

# TraversableOnce

#### trait TraversableOnce[+A] extends GenTraversableOnce[A]

A template trait for collections which can be traversed either once only or one or more times.

This trait exists primarily to eliminate code duplication between `Iterator` and `Traversable`, and thus implements some of the common methods that can be implemented solely in terms of foreach without access to a `Builder`. It also includes a number of abstract methods whose implementations are provided by `Iterator`, `Traversable`, etc. It contains implementations common to `Iterators` and `Traversables`, such as folds, conversions, and other operations which traverse some or all of the elements and return a derived value. Directly subclassing `TraversableOnce` is not recommended - instead, consider declaring an `Iterator` with a `next` and `hasNext` method, creating an `Iterator` with one of the methods on the `Iterator` object, or declaring a subclass of `Traversable`.

A

  the element type of the collection

Self Type
  TraversableOnce[A]
Source
  TraversableOnce.scala
Version

  2.8

Since

  2.8

Linear Supertypes
GenTraversableOnce[A], AnyRef, Any
Known Subclasses
::, AbsScope, Appended, Appended, Appended, Appended, Appended, Appended, ArrayBuffer, ArrayLike, ArrayOps, ArraySeq, ArrayStack, Atom, Attribute, BitSet, BitSet, BitSet, BitSet1, BitSet2, BitSetLike, BitSetN, Buffer, BufferLike, BufferProxy, BufferWrapper, BufferedIterator, BufferedLineIterator, BufferedSource, ByOne, Comment, ConcurrentMap, Cons, Content, CountedIterator, DefaultKeySet, DefaultKeySortedSet, DefaultKeySortedSet, DefaultMap, DefaultMap, DefaultMapModel, DefaultValuesIterable, Document, DoubleLinkedList, DoubleLinkedListLike, DroppedWhile, DroppedWhile, DroppedWhile, DroppedWhile, DroppedWhile, Elem, Elements, Elements, Empty, EmptyMap, EmptyMap, EmptySet, EmptySet, EmptyView, EmptyView, EmptyView, EmptyView, EntityRef, EntryIterator, Exclusive, Filtered, Filtered, Filtered, Filtered, Filtered, FlatMapped, FlatMapped, FlatMapped, FlatMapped, Forced, Forced, Forced, Forced, Group, GroupedIterator, HashMap, HashMap, HashMap1, HashSet, HashSet, HashSet1, HashTrieMap, HashTrieSet, History, ImmutableDefaultKeySet, ImmutableMapAdaptor, ImmutableSetAdaptor, Impl, Inclusive, Inclusive, IndexedSeq, IndexedSeq, IndexedSeq, IndexedSeqLike, IndexedSeqLike, IndexedSeqOptimized, IndexedSeqOptimized, IndexedSeqView, Indices, IntMap, Iterable, Iterable, Iterable, IterableForwarder, IterableLike, IterableProxy, IterableProxyLike, IterableSplitter, IterableView, IterableViewLike, Iterator, JCollectionWrapper, JConcurrentMapWrapper, JDictionaryWrapper, JEnumerationWrapper, JIterableWrapper, JIteratorWrapper, JListWrapper, JMapWrapper, JMapWrapperLike, JPropertiesWrapper, JSetWrapper, LineIterator, LinearSeq, LinearSeq, LinearSeq, LinearSeqLike, LinearSeqOptimized, LinkedHashMap, LinkedHashSet, LinkedList, LinkedListLike, List, ListBuffer, ListMap, ListMap, ListSet, LongMap, Map, Map, Map, Map1, Map2, Map3, Map4, MapLike, MapLike, MapLike, MapProxy, MapProxy, MapProxy, MapProxyLike, Mapped, Mapped, Mapped, Mapped, Mapped, Mapped, MatchIterator, MetaData, MultiMap, MutableList, Nil, Node, Node, Node, NodeBuffer, NodeSeq, Null, NumericRange, ObservableBuffer, ObservableMap, ObservableSet, OpenHashMap, PCData, PagedSeq, ParArrayIterator, ParFlatHashTableIterator, ParHashMapIterator, ParHashMapIterator, ParHashSetIterator, ParHashSetIterator, ParIterator, ParIterator, ParRangeIterator, ParVectorIterator, Patched, Patched, Patched, PicklerEnv, PreciseSplitter, PrefixedAttribute, Prepended, Prepended, PriorityQueue, PriorityQueueProxy, ProcInstr, ProducerConsumerIterator, Queue, Queue, QueueProxy, Range, RefBuffer, ResizableArray, Reversed, Reversed, Reversed, RevertibleHistory, Scope, Script, SelectionSet, Seq, Seq, Seq, SeqForwarder, SeqLike, SeqLike, SeqProxy, SeqProxyLike, SeqSplitter, SeqView, SeqViewLike, Set, Set, Set, Set1, Set2, Set3, Set4, SetLike, SetLike, SetProxy, SetProxy, SetProxy, SetProxyLike, SignalContextPassingIterator, SignalContextPassingIterator, Sliced, Sliced, Sliced, Sliced, Sliced, SortedMap, SortedMap, SortedMapLike, SortedSet, SortedSet, SortedSetLike, Source, SpecialNode, Splitter, Stack, Stack, StackProxy, Stream, StreamIterator, StreamView, StreamViewLike, StringBuilder, StringLike, StringOps, SynchronizedBuffer, SynchronizedMap, SynchronizedPriorityQueue, SynchronizedQueue, SynchronizedSet, SynchronizedStack, SystemProperties, Taken, Taken, TakenWhile, TakenWhile, TakenWhile, TakenWhile, TakenWhile, Text, Transformed, Transformed, Transformed, Transformed, Transformed, Traversable, Traversable, Traversable, TraversableForwarder, TraversableLike, TraversableProxy, TraversableProxyLike, TraversableView, TraversableViewLike, TreeMap, TreeSet, UnPicklerEnv, Unparsed, UnprefixedAttribute, UnrolledBuffer, ValueSet, Vector, VectorIterator, WeakHashMap, WithDefault, WithDefault, WithDefault, WrappedArray, WrappedString, XMLEventReader, Zipped, Zipped, Zipped, Zipped, Zipped, ZippedAll, ZippedAll, ZippedAll, ZippedAll, ZippedAll, columns, indices, ofBoolean, ofBoolean, ofByte, ofByte, ofChar, ofChar, ofDouble, ofDouble, ofFloat, ofFloat, ofInt, ofInt, ofLong, ofLong, ofRef, ofRef, ofShort, ofShort, ofUnit, ofUnit, pages, rows
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. TraversableOnce
2. GenTraversableOnce
3. AnyRef
4. Any

Visibility

1. Public
2. All

### Abstract Value Members

1. #### abstract def copyToArray[B >: A](xs: Array[B], start: Int, len: Int): Unit

   Definition Classes
     TraversableOnce → GenTraversableOnce

2. #### abstract def exists(p: (A) ⇒ Boolean): Boolean

   Definition Classes
     TraversableOnce → GenTraversableOnce

3. #### abstract def find(p: (A) ⇒ Boolean): Option[A]

   Finds the first element of the traversable or iterator satisfying a predicate, if any.

   Finds the first element of the traversable or iterator satisfying a predicate, if any.

   Note: may not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered.

   p

     the predicate used to test elements.

   returns

     an option value containing the first element in the traversable or iterator that satisfies `p`, or `None` if none exists.

   Definition Classes
     TraversableOnce → GenTraversableOnce

4. #### abstract def forall(p: (A) ⇒ Boolean): Boolean

   Presently these are abstract because the Traversable versions use breakable/break, and I wasn't sure enough of how that's supposed to function to consolidate them with the Iterator versions.

   Presently these are abstract because the Traversable versions use breakable/break, and I wasn't sure enough of how that's supposed to function to consolidate them with the Iterator versions.

   Definition Classes
     TraversableOnce → GenTraversableOnce

5. #### abstract def foreach[U](f: (A) ⇒ U): Unit

   Self-documenting abstract methods.

   Self-documenting abstract methods.

   Definition Classes
     TraversableOnce → GenTraversableOnce

6. #### abstract def hasDefiniteSize: Boolean

   Definition Classes
     TraversableOnce → GenTraversableOnce

7. #### abstract def isEmpty: Boolean

   Tests whether the traversable or iterator is empty.

   Tests whether the traversable or iterator is empty.

   returns

     `true` if the traversable or iterator contains no elements, `false` otherwise.

   Definition Classes
     TraversableOnce → GenTraversableOnce

8. #### abstract def isTraversableAgain: Boolean

   Tests whether this traversable or iterator can be repeatedly traversed.

   Tests whether this traversable or iterator can be repeatedly traversed. Always true for Traversables and false for Iterators unless overridden.

   returns

     `true` if it is repeatedly traversable, `false` otherwise.

   Definition Classes
     GenTraversableOnce

9. #### abstract def seq: TraversableOnce[A]

   A version of this collection with all of the operations implemented sequentially (i.

   A version of this collection with all of the operations implemented sequentially (i.e. in a single-threaded manner).

   This method returns a reference to this collection. In parallel collections, it is redefined to return a sequential implementation of this collection. In both cases, it has O(1) complexity.

   returns

     a sequential view of the collection.

   Definition Classes
     TraversableOnce → GenTraversableOnce

10. #### abstract def toIterator: Iterator[A]

    Returns an Iterator over the elements in this traversable or iterator.

    Returns an Iterator over the elements in this traversable or iterator. Will return the same Iterator if this instance is already an Iterator.

    Note: will not terminate for infinite-sized collections.

    returns

      an Iterator containing all elements of this traversable or iterator.

    Definition Classes
      GenTraversableOnce

11. #### abstract def toStream: Stream[A]

    Converts this traversable or iterator to a stream.

    Converts this traversable or iterator to a stream.

    Note: will not terminate for infinite-sized collections.

    returns

      a stream containing all elements of this traversable or iterator.

    Definition Classes
      GenTraversableOnce

12. #### abstract def toTraversable: Traversable[A]

    Converts this traversable or iterator to an unspecified Traversable.

    Converts this traversable or iterator to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

    Note: will not terminate for infinite-sized collections.

    returns

      a Traversable containing all elements of this traversable or iterator.

    Definition Classes
      TraversableOnce → GenTraversableOnce

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def /:[B](z: B)(op: (B, A) ⇒ B): B

   Applies a binary operator to a start value and all elements of this traversable or iterator, going left to right.

   Applies a binary operator to a start value and all elements of this traversable or iterator, going left to right.

   Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

            scala> val a = LinkedList(1,2,3,4)
            a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

            scala> val b = (5 /: a)(_+_)
            b: Int = 15

            scala> val c = (5 /: a)((x,y) => x + y)
            c: Int = 15

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

   B

     the result type of the binary operator.

   z

     the start value.

   op

     the binary operator.

   returns

     the result of inserting `op` between consecutive elements of this traversable or iterator, going left to right with the start value `z` on the left:

                     op(...op(op(z, x1), x2), ..., xn)

     where `x1, ..., xn` are the elements of this traversable or iterator.

   Definition Classes
     TraversableOnce → GenTraversableOnce

5. #### def /:\[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

   A syntactic sugar for out of order folding.

   A syntactic sugar for out of order folding. See `fold`.

   Example:

            scala> val a = LinkedList(1,2,3,4)
            a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

            scala> val b = (a /:\ 5)(_+_)
            b: Int = 15

   Definition Classes
     GenTraversableOnce

6. #### def :\[B](z: B)(op: (A, B) ⇒ B): B

   Applies a binary operator to all elements of this traversable or iterator and a start value, going right to left.

   Applies a binary operator to all elements of this traversable or iterator and a start value, going right to left.

   Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

            scala> val a = LinkedList(1,2,3,4)
            a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

            scala> val b = (a :\ 5)(_+_)
            b: Int = 15

            scala> val c = (a :\ 5)((x,y) => x + y)
            c: Int = 15

   B

     the result type of the binary operator.

   z

     the start value

   op

     the binary operator

   returns

     the result of inserting `op` between consecutive elements of this traversable or iterator, going right to left with the start value `z` on the right:

                     op(x1, op(x2, ... op(xn, z)...))

     where `x1, ..., xn` are the elements of this traversable or iterator.

   Definition Classes
     TraversableOnce → GenTraversableOnce

7. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

8. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

9. #### def addString(b: StringBuilder): StringBuilder

   Appends all elements of this traversable or iterator to a string builder.

   Appends all elements of this traversable or iterator to a string builder. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator without any separator string.

   Example:

            scala> val a = LinkedList(1,2,3,4)
            a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

            scala> val b = new StringBuilder()
            b: StringBuilder =

            scala> val h = a.addString(b)
            b: StringBuilder = 1234

   b

     the string builder to which elements are appended.

   returns

     the string builder `b` to which elements were appended.

10. #### def addString(b: StringBuilder, sep: String): StringBuilder

    Appends all elements of this traversable or iterator to a string builder using a separator string.

    Appends all elements of this traversable or iterator to a string builder using a separator string. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator, separated by the string `sep`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> a.addString(b, ", ")
             res0: StringBuilder = 1, 2, 3, 4

    b

      the string builder to which elements are appended.

    sep

      the separator string.

    returns

      the string builder `b` to which elements were appended.

11. #### def addString(b: StringBuilder, start: String, sep: String, end: String): StringBuilder

    Appends all elements of this traversable or iterator to a string builder using start, end, and separator strings.

    Appends all elements of this traversable or iterator to a string builder using start, end, and separator strings. The written text begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator are separated by the string `sep`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> a.addString(b, "LinkedList(", ", ", ")")
             res1: StringBuilder = LinkedList(1, 2, 3, 4)

    b

      the string builder to which elements are appended.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      the string builder `b` to which elements were appended.

12. #### def aggregate[B](z: B)(seqop: (B, A) ⇒ B, combop: (B, B) ⇒ B): B

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked an arbitrary number of times.

    For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

           pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

    Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

    B

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation)

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      TraversableOnce → GenTraversableOnce

13. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

14. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

15. #### def collectFirst[B](pf: PartialFunction[A, B]): Option[B]

    Finds the first element of the traversable or iterator for which the given partial function is defined, and applies the partial function to it.

    Finds the first element of the traversable or iterator for which the given partial function is defined, and applies the partial function to it.

    Note: may not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    pf

      the partial function

    returns

      an option value containing pf applied to the first value for which it is defined, or `None` if none exists.

    Example:

    1. `Seq("a", 1, 5L).collectFirst({ case x: Int => x*10 }) = Some(10)`

16. #### abstract def copyToArray(xs: Array[A]): Unit

    [use case] Copies values of this traversable or iterator to an array.

    [use case]

    Copies values of this traversable or iterator to an array. Fills the given array `xs` with values of this traversable or iterator. Copying will stop once either the end of the current traversable or iterator is reached, or the end of the array is reached.

    xs

      the array to fill.

    Definition Classes
      GenTraversableOnce

17. #### def copyToArray[B >: A](xs: Array[B]): Unit

    Copies values of this traversable or iterator to an array.

    Copies values of this traversable or iterator to an array. Fills the given array `xs` with values of this traversable or iterator. Copying will stop once either the end of the current traversable or iterator is reached, or the end of the array is reached.

    Note: will not terminate for infinite-sized collections.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    Definition Classes
      TraversableOnce → GenTraversableOnce

18. #### abstract def copyToArray(xs: Array[A], start: Int): Unit

    [use case] Copies values of this traversable or iterator to an array.

    [use case]

    Copies values of this traversable or iterator to an array. Fills the given array `xs` with values of this traversable or iterator, beginning at index `start`. Copying will stop once either the end of the current traversable or iterator is reached, or the end of the array is reached.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      GenTraversableOnce

19. #### def copyToArray[B >: A](xs: Array[B], start: Int): Unit

    Copies values of this traversable or iterator to an array.

    Copies values of this traversable or iterator to an array. Fills the given array `xs` with values of this traversable or iterator, beginning at index `start`. Copying will stop once either the end of the current traversable or iterator is reached, or the end of the array is reached.

    Note: will not terminate for infinite-sized collections.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      TraversableOnce → GenTraversableOnce

20. #### def copyToBuffer[B >: A](dest: Buffer[B]): Unit

    Copies all elements of this traversable or iterator to a buffer.

    Copies all elements of this traversable or iterator to a buffer.

    Note: will not terminate for infinite-sized collections.

    dest

      The buffer to which elements are copied.

21. #### def count(p: (A) ⇒ Boolean): Int

    Counts the number of elements in the traversable or iterator which satisfy a predicate.

    Counts the number of elements in the traversable or iterator which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

22. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

23. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. See equals in Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

24. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

25. #### def fold[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

    Folds the elements of this traversable or iterator using the specified associative binary operator.

    Folds the elements of this traversable or iterator using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      a type parameter for the binary operator, a supertype of `A`.

    z

      a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication.)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      TraversableOnce → GenTraversableOnce

26. #### def foldLeft[B](z: B)(op: (B, A) ⇒ B): B

    Applies a binary operator to a start value and all elements of this traversable or iterator, going left to right.

    Applies a binary operator to a start value and all elements of this traversable or iterator, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this traversable or iterator, going left to right with the start value `z` on the left:

                      op(...op(z, x1), x2, ..., xn)

      where `x1, ..., xn` are the elements of this traversable or iterator.

    Definition Classes
      TraversableOnce → GenTraversableOnce

27. #### def foldRight[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this traversable or iterator and a start value, going right to left.

    Applies a binary operator to all elements of this traversable or iterator and a start value, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this traversable or iterator, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this traversable or iterator.

    Definition Classes
      TraversableOnce → GenTraversableOnce

28. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

29. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

30. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

31. #### abstract def max: A

    [use case] Finds the largest element.

    [use case]

    Finds the largest element.

    returns

      the largest element of this traversable or iterator with respect to the ordering `cmp`.

    Definition Classes
      GenTraversableOnce

32. #### def max[B >: A](implicit cmp: Ordering[B]): A

    Finds the largest element.

    Finds the largest element.

    B

      The type over which the ordering is defined.

    cmp

      An ordering to be used for comparing elements.

    returns

      the largest element of this traversable or iterator with respect to the ordering `cmp`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

33. #### def maxBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

    Definition Classes
      TraversableOnce → GenTraversableOnce

34. #### abstract def min: A

    [use case] Finds the smallest element.

    [use case]

    Finds the smallest element.

    returns

      the smallest element of this traversable or iterator with respect to the ordering `cmp`.

    Definition Classes
      GenTraversableOnce

35. #### def min[B >: A](implicit cmp: Ordering[B]): A

    Finds the smallest element.

    Finds the smallest element.

    B

      The type over which the ordering is defined.

    cmp

      An ordering to be used for comparing elements.

    returns

      the smallest element of this traversable or iterator with respect to the ordering `cmp`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

36. #### def minBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

    Definition Classes
      TraversableOnce → GenTraversableOnce

37. #### def mkString: String

    Displays all elements of this traversable or iterator in a string.

    Displays all elements of this traversable or iterator in a string.

    returns

      a string representation of this traversable or iterator. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator follow each other without any separator string.

    Definition Classes
      TraversableOnce → GenTraversableOnce

38. #### def mkString(sep: String): String

    Displays all elements of this traversable or iterator in a string using a separator string.

    Displays all elements of this traversable or iterator in a string using a separator string.

    sep

      the separator string.

    returns

      a string representation of this traversable or iterator. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator are separated by the string `sep`.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("|") = "1|2|3"`

39. #### def mkString(start: String, sep: String, end: String): String

    Displays all elements of this traversable or iterator in a string using start, end, and separator strings.

    Displays all elements of this traversable or iterator in a string using start, end, and separator strings.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      a string representation of this traversable or iterator. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator are separated by the string `sep`.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

40. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

41. #### def nonEmpty: Boolean

    Tests whether the traversable or iterator is not empty.

    Tests whether the traversable or iterator is not empty.

    returns

      `true` if the traversable or iterator contains at least one element, `false` otherwise.

    Definition Classes
      TraversableOnce → GenTraversableOnce

42. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

43. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

44. #### abstract def product: A

    [use case] Multiplies up the elements of this collection.

    [use case]

    Multiplies up the elements of this collection.

    returns

      the product of all elements of this traversable or iterator with respect to the `*` operator in `num`.

    Definition Classes
      GenTraversableOnce

45. #### def product[B >: A](implicit num: Numeric[B]): B

    Multiplies up the elements of this collection.

    Multiplies up the elements of this collection.

    B

      the result type of the `*` operator.

    num

      an implicit parameter defining a set of numeric operations which includes the `*` operator to be used in forming the product.

    returns

      the product of all elements of this traversable or iterator with respect to the `*` operator in `num`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

46. #### def reduce[A1 >: A](op: (A1, A1) ⇒ A1): A1

    Reduces the elements of this traversable or iterator using the specified associative binary operator.

    Reduces the elements of this traversable or iterator using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      A type parameter for the binary operator, a supertype of `A`.

    op

      A binary operator that must be associative.

    returns

      The result of applying reduce operator `op` between all the elements if the traversable or iterator is nonempty.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Exceptions thrown
      UnsupportedOperationException

      if this traversable or iterator is empty.

47. #### def reduceLeft[B >: A](op: (B, A) ⇒ B): B

48. #### def reduceLeftOption[B >: A](op: (B, A) ⇒ B): Option[B]

    Optionally applies a binary operator to all elements of this traversable or iterator, going left to right.

    Optionally applies a binary operator to all elements of this traversable or iterator, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceLeft(op)` is this traversable or iterator is nonempty, `None` otherwise.

    Definition Classes
      TraversableOnce → GenTraversableOnce

49. #### def reduceOption[A1 >: A](op: (A1, A1) ⇒ A1): Option[A1]

    Reduces the elements of this traversable or iterator, if any, using the specified associative binary operator.

    Reduces the elements of this traversable or iterator, if any, using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      A type parameter for the binary operator, a supertype of `A`.

    op

      A binary operator that must be associative.

    returns

      An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

    Definition Classes
      TraversableOnce → GenTraversableOnce

50. #### def reduceRight[B >: A](op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this traversable or iterator, going right to left.

    Applies a binary operator to all elements of this traversable or iterator, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this traversable or iterator, going right to left:

                      op(x,,1,,, op(x,,2,,, ..., op(x,,n-1,,, x,,n,,)...))

      where `x1, ..., xn` are the elements of this traversable or iterator.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Exceptions thrown
      `UnsupportedOperationException`

      if this traversable or iterator is empty.

51. #### def reduceRightOption[B >: A](op: (A, B) ⇒ B): Option[B]

    Optionally applies a binary operator to all elements of this traversable or iterator, going right to left.

    Optionally applies a binary operator to all elements of this traversable or iterator, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceRight(op)` is this traversable or iterator is nonempty, `None` otherwise.

    Definition Classes
      TraversableOnce → GenTraversableOnce

52. #### def reversed: List[A]

    Attributes
      protected[this]

53. #### def size: Int

    The size of this traversable or iterator.

    The size of this traversable or iterator.

    Note: will not terminate for infinite-sized collections.

    returns

      the number of elements in this traversable or iterator.

    Definition Classes
      TraversableOnce → GenTraversableOnce

54. #### abstract def sum: A

    [use case] Sums up the elements of this collection.

    [use case]

    Sums up the elements of this collection.

    returns

      the sum of all elements of this traversable or iterator with respect to the `+` operator in `num`.

    Definition Classes
      GenTraversableOnce

55. #### def sum[B >: A](implicit num: Numeric[B]): B

    Sums up the elements of this collection.

    Sums up the elements of this collection.

    B

      the result type of the `+` operator.

    num

      an implicit parameter defining a set of numeric operations which includes the `+` operator to be used in forming the sum.

    returns

      the sum of all elements of this traversable or iterator with respect to the `+` operator in `num`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

56. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

57. #### abstract def toArray: Array[A]

    [use case] Converts this traversable or iterator to an array.

    [use case]

    Converts this traversable or iterator to an array.

    Note: will not terminate for infinite-sized collections.

    returns

      an array containing all elements of this traversable or iterator.

    Definition Classes
      GenTraversableOnce

58. #### def toArray[B >: A](implicit arg0: ClassManifest[B]): Array[B]

    Converts this traversable or iterator to an array.

    Converts this traversable or iterator to an array.

    Note: will not terminate for infinite-sized collections.

    B

      the type of the elements of the array. A `ClassManifest` for this type must be available.

    returns

      an array containing all elements of this traversable or iterator.

    Definition Classes
      TraversableOnce → GenTraversableOnce

59. #### def toBuffer[B >: A]: Buffer[B]

    Converts this traversable or iterator to a mutable buffer.

    Converts this traversable or iterator to a mutable buffer.

    Note: will not terminate for infinite-sized collections.

    returns

      a buffer containing all elements of this traversable or iterator.

    Definition Classes
      TraversableOnce → GenTraversableOnce

60. #### def toIndexedSeq[B >: A]: IndexedSeq[B]

    Converts this traversable or iterator to an indexed sequence.

    Converts this traversable or iterator to an indexed sequence.

    Note: will not terminate for infinite-sized collections.

    returns

      an indexed sequence containing all elements of this traversable or iterator.

    Definition Classes
      TraversableOnce → GenTraversableOnce

61. #### def toIterable: Iterable[A]

    Converts this traversable or iterator to an iterable collection.

    Converts this traversable or iterator to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

    Note: will not terminate for infinite-sized collections.

    returns

      an `Iterable` containing all elements of this traversable or iterator.

    Definition Classes
      TraversableOnce → GenTraversableOnce

62. #### def toList: List[A]

    Converts this traversable or iterator to a list.

    Converts this traversable or iterator to a list.

    Note: will not terminate for infinite-sized collections.

    returns

      a list containing all elements of this traversable or iterator.

    Definition Classes
      TraversableOnce → GenTraversableOnce

63. #### abstract def toMap[T, U]: Map[T, U]

    [use case] Converts this traversable or iterator to a map.

    [use case]

    Converts this traversable or iterator to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

    Note: will not terminate for infinite-sized collections.

    returns

      a map containing all elements of this traversable or iterator.

    Definition Classes
      GenTraversableOnce

64. #### def toMap[T, U](implicit ev: <:<[A, (T, U)]): Map[T, U]

    Converts this traversable or iterator to a map.

    Converts this traversable or iterator to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

    Note: will not terminate for infinite-sized collections.

    returns

      a map containing all elements of this traversable or iterator.

    Definition Classes
      TraversableOnce → GenTraversableOnce

65. #### def toSeq: Seq[A]

    Converts this traversable or iterator to a sequence.

    Converts this traversable or iterator to a sequence. As with `toIterable`, it's lazy in this default implementation, as this `TraversableOnce` may be lazy and unevaluated.

    Note: will not terminate for infinite-sized collections.

    returns

      a sequence containing all elements of this traversable or iterator.

    Definition Classes
      TraversableOnce → GenTraversableOnce

66. #### def toSet[B >: A]: Set[B]

    Converts this traversable or iterator to a set.

    Converts this traversable or iterator to a set.

    Note: will not terminate for infinite-sized collections.

    returns

      a set containing all elements of this traversable or iterator.

    Definition Classes
      TraversableOnce → GenTraversableOnce

67. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

68. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

69. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

70. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

### Inherited from GenTraversableOnce[A]

### Inherited from AnyRef

### Inherited from Any